Subject: Re: bug#52553: b4 build failure

From: Kyle Meyer <[email-masked]>
Date: Sat, 18 Dec 2021 01:39:20 -0500

Aleksandr Vityazev writes:

> Hello,
>
> The b4 package sanity-check phase failure:
>
> --8<---------------cut here---------------start------------->8---
> starting phase `sanity-check'
> validating 'b4' /gnu/store/4fm7zp1kimv5cq8dvkn89a3vjpwcfbi1-b4-0.6.2/lib/python3.9/site-packages
[...]
>   File "/gnu/store/4fm7zp1kimv5cq8dvkn89a3vjpwcfbi1-b4-0.6.2/lib/python3.9/site-packages/b4/__init__.py", line 36, in <module>
>     _resolver = dns.resolver.get_default_resolver()
>   File "/gnu/store/0wlsxxxwmq56wra88c8cvzsk3xfh75m1-python-dnspython-2.1.0/lib/python3.9/site-packages/dns/resolver.py", line 1278, in get_default_resolver
>     reset_default_resolver()
>   File "/gnu/store/0wlsxxxwmq56wra88c8cvzsk3xfh75m1-python-dnspython-2.1.0/lib/python3.9/site-packages/dns/resolver.py", line 1290, in reset_default_resolver
>     default_resolver = Resolver()
>   File "/gnu/store/0wlsxxxwmq56wra88c8cvzsk3xfh75m1-python-dnspython-2.1.0/lib/python3.9/site-packages/dns/resolver.py", line 734, in __init__
>     self.read_resolv_conf(filename)
>   File "/gnu/store/0wlsxxxwmq56wra88c8cvzsk3xfh75m1-python-dnspython-2.1.0/lib/python3.9/site-packages/dns/resolver.py", line 785, in read_resolv_conf
>     raise NoResolverConfiguration
> dns.resolver.NoResolverConfiguration: Resolver configuration could not be read or specified no nameservers.
> ...trying to load endpoint console_scripts b4: ERROR:
> Traceback (most recent call last):
>   File "/gnu/store/0wlsxxxwmq56wra88c8cvzsk3xfh75m1-python-dnspython-2.1.0/lib/python3.9/site-packages/dns/resolver.py", line 782, in read_resolv_conf
>     f = stack.enter_context(open(f))
> FileNotFoundError: [Errno 2] No such file or directory: '/etc/resolv.conf'

Thanks for reporting.

> I don't know how good the solution is, but if you remove the
> sanity-check phase, the package builds and works.

The latest version of b4 no longer calls dnspython's
get_default_resolver(), so it avoids this failure.  I posted a series
for that update at https://debbugs.gnu.org/48702
(<[email-masked]>).  It's a bit stale at this
point and has conflicts with the current master.  I'll rebase it and
send new version.